Index: external/fastjet/CompositeJetStructure.hh
===================================================================
--- external/fastjet/CompositeJetStructure.hh	(revision f14bd6a232a0c5f940f327c1f36da027f253ff56)
+++ external/fastjet/CompositeJetStructure.hh	(revision 273e6686a07d03a86d9d25838b441c09754bdc34)
@@ -1,4 +1,4 @@
 //FJSTARTHEADER
-// $Id: CompositeJetStructure.hh 3453 2014-07-25 07:44:32Z soyez $
+// $Id: CompositeJetStructure.hh 3652 2014-09-03 13:31:13Z salam $
 //
 // Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
@@ -244,4 +244,5 @@
 				    const JetDefinition::Recombiner & recombiner){
   std::vector<PseudoJet> pieces;
+  pieces.reserve(2);
   pieces.push_back(j1);
   pieces.push_back(j2);
@@ -255,4 +256,5 @@
 				    const JetDefinition::Recombiner & recombiner){
   std::vector<PseudoJet> pieces;
+  pieces.reserve(3);
   pieces.push_back(j1);
   pieces.push_back(j2);
@@ -267,4 +269,5 @@
 				    const JetDefinition::Recombiner & recombiner){
   std::vector<PseudoJet> pieces;
+  pieces.reserve(4);
   pieces.push_back(j1);
   pieces.push_back(j2);
Index: external/fastjet/Error.cc
===================================================================
--- external/fastjet/Error.cc	(revision f14bd6a232a0c5f940f327c1f36da027f253ff56)
+++ external/fastjet/Error.cc	(revision 273e6686a07d03a86d9d25838b441c09754bdc34)
@@ -1,4 +1,4 @@
 //FJSTARTHEADER
-// $Id: Error.cc 3433 2014-07-23 08:17:03Z salam $
+// $Id: Error.cc 3695 2014-09-18 13:57:56Z cacciari $
 //
 // Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
@@ -33,9 +33,15 @@
 #include <sstream>
 
+#ifndef __FJCORE__
 // printing the stack would need execinfo
 #ifdef FASTJET_HAVE_EXECINFO_H
 #include <execinfo.h>
 #include <cstdlib>
-#endif
+#ifdef FASTJET_HAVE_DEMANGLING_SUPPORT
+#include <cstdio>
+#include <cxxabi.h>
+#endif // FASTJET_HAVE_DEMANGLING_SUPPORT
+#endif // FASTJET_HAVE_EXECINFO_H
+#endif  // __FJCORE__
 
 FASTJET_BEGIN_NAMESPACE      // defined in fastjet/internal/base.hh
@@ -46,11 +52,70 @@
 bool Error::_print_backtrace = false;
 ostream * Error::_default_ostr = & cerr;
+#if (!defined(FASTJET_HAVE_EXECINFO_H)) || defined(__FJCORE__)
+  LimitedWarning Error::_execinfo_undefined;
+#endif
 
+//----------------------------------------------------------------------
+#ifndef __FJCORE__ 
+
+// demangling only is included, i.e. --enable-demangling is specified
+// at configure time, execinfo.h is present and the GNU C++ ABI is
+// supported
+#if defined(FASTJET_HAVE_EXECINFO_H) && defined(FASTJET_HAVE_DEMANGLING_SUPPORT)
+// demangle a given backtrace symbol
+//
+// Notes:
+//  - at the moment, only the symbol is parsed.
+//  - one can get the offset by using 
+//      "%*[^(]%*[^_]%127[^+)]%64[+x0123456789abcdef]", symbol, offset
+//    and checking if sscanf returns 0, 1 or 2
+//    (offset includes the leading +)
+//  - Similarly one could exctract the address and try to convert it
+//    into a filename+line number like addr2line does but this seems
+//    to require exteral dependencies. If we want to go down that
+//    route, one could look into the inplementation o faddr2line(.c)
+//    and/or dladdr.
+string Error::_demangle(const char* symbol) {
+  size_t size;
+  int status;
+  char temp[128];
+  char* demangled;
+  // first, try to demangle a c++ name
+  // decryption:
+  //   %*[^(]  matches any number of characters different from "("
+  //           the * tells not to store in input var 
+  //   %*[^_]  matches any number of characters different from "_"
+  //           the * tells not to store in input var 
+  //   %127[^)+]  matches at most 127 characters different from "+"
+  //              match is stored
+  if (1 == sscanf(symbol, "%*[^(]%*[^_]%127[^)+]", temp)) {
+    //cout << symbol << " -> " << temp << endl;
+    if (NULL != (demangled = abi::__cxa_demangle(temp, NULL, &size, &status))) {
+      string result(demangled);
+      free(demangled);
+      return result;
+    }
+  }
+  //if that didn't work, try to get a regular c symbol
+  if (1 == sscanf(symbol, "%127s", temp)) {
+    return temp;
+  }
+ 
+  //if all else fails, just return the symbol
+  return symbol;
+}
+#endif  // FASTJET_HAVE_DEMANGLING_SUPPORT && FASTJET_HAVE_EXECINFO_H
+#endif  // __FJCORE__
+
+
+//----------------------------------------------------------------------
 Error::Error(const std::string & message_in) {
   _message = message_in; 
+
   if (_print_errors && _default_ostr){
     ostringstream oss;
     oss << "fastjet::Error:  "<< message_in << endl;
 
+#ifndef __FJCORE__
     // only print the stack if execinfo is available and stack enabled
 #ifdef FASTJET_HAVE_EXECINFO_H
@@ -64,9 +129,15 @@
       oss << "stack:" << endl;
       for (int i = 1; i < size && messages != NULL; ++i){
+#ifdef FASTJET_HAVE_DEMANGLING_SUPPORT
+	oss << "  #" << i << ": " << _demangle(messages[i])
+	    << " [" << messages[i]  << "]" << endl;
+#else
 	oss << "  #" << i << ": " << messages[i] << endl;
+#endif
       }
       free(messages);
     }
-#endif
+#endif  // FASTJET_HAVE_EXECINFO_H
+#endif  // __FJCORE__
 
     *_default_ostr << oss.str();
@@ -85,4 +156,14 @@
 }
 
+//----------------------------------------------------------------------
+void Error::set_print_backtrace(bool enabled) {
+#if (!defined(FASTJET_HAVE_EXECINFO_H)) || defined(__FJCORE__)
+  if (enabled) {
+    _execinfo_undefined.warn("Error::set_print_backtrace(true) will not work with this build of FastJet");
+  }
+#endif    
+  _print_backtrace = enabled;
+}
+
 FASTJET_END_NAMESPACE
 
Index: external/fastjet/Error.hh
===================================================================
--- external/fastjet/Error.hh	(revision f14bd6a232a0c5f940f327c1f36da027f253ff56)
+++ external/fastjet/Error.hh	(revision 273e6686a07d03a86d9d25838b441c09754bdc34)
@@ -3,5 +3,5 @@
 
 //FJSTARTHEADER
-// $Id: Error.hh 3433 2014-07-23 08:17:03Z salam $
+// $Id: Error.hh 3694 2014-09-18 13:21:54Z soyez $
 //
 // Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
@@ -35,4 +35,8 @@
 #include<string>
 #include "fastjet/internal/base.hh"
+#include "fastjet/config.h"
+#if (!defined(FASTJET_HAVE_EXECINFO_H)) || defined(__FJCORE__)
+#include "fastjet/LimitedWarning.hh"
+#endif
 
 FASTJET_BEGIN_NAMESPACE      // defined in fastjet/internal/base.hh
@@ -65,5 +69,5 @@
   /// controls whether the backtrace is printed out with the error message or not.
   /// The default is "false".
-  static void set_print_backtrace(bool enabled) {_print_backtrace = enabled;}
+  static void set_print_backtrace(bool enabled);
 
   /// sets the default output stream for all errors; by default
@@ -74,8 +78,19 @@
 
 private:
+
+#ifndef __FJCORE__
+#if defined(FASTJET_HAVE_EXECINFO_H) && defined(FASTJET_HAVE_DEMANGLING_SUPPORT)
+  /// demangle a given backtrace symbol
+  std::string _demangle(const char* symbol);
+#endif
+#endif
+
   std::string _message;                ///< error message
   static bool _print_errors;           ///< do we print anything?
   static bool _print_backtrace;        ///< do we print the backtrace?
   static std::ostream * _default_ostr; ///< the output stream (cerr if not set)
+#if (!defined(FASTJET_HAVE_EXECINFO_H)) || defined(__FJCORE__)
+  static LimitedWarning _execinfo_undefined;
+#endif
 };
 
Index: external/fastjet/JetDefinition.cc
===================================================================
--- external/fastjet/JetDefinition.cc	(revision f14bd6a232a0c5f940f327c1f36da027f253ff56)
+++ external/fastjet/JetDefinition.cc	(revision 273e6686a07d03a86d9d25838b441c09754bdc34)
@@ -1,4 +1,4 @@
 //FJSTARTHEADER
-// $Id: JetDefinition.cc 3492 2014-07-30 16:58:20Z soyez $
+// $Id: JetDefinition.cc 3677 2014-09-09 22:45:25Z soyez $
 //
 // Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
@@ -270,4 +270,13 @@
   case BIpt2_scheme:
     return "boost-invariant pt2 scheme recombination";
+  case WTA_pt_scheme:
+    return "pt-ordered Winner-Takes-All recombination";
+  // Energy-ordering can lead to dangerous situations with particles at
+  // rest. We instead implement the WTA_modp_scheme
+  //
+  //   case WTA_E_scheme:
+  //     return "energy-ordered Winner-Takes-All recombination";
+  case WTA_modp_scheme:
+    return "|3-momentum|-ordered Winner-Takes-All recombination";
   default:
     ostringstream err;
@@ -309,4 +318,50 @@
     weightb = pb.perp2();
     break;
+  case WTA_pt_scheme:{
+    const PseudoJet & phard = (pa.pt2() >= pb.pt2()) ? pa : pb;
+    /// keep y,phi and m from the hardest, sum pt
+    pab.reset_PtYPhiM(pa.pt()+pb.pt(), 
+                      phard.rap(), phard.phi(), phard.m());
+    return;}
+  // Energy-ordering can lead to dangerous situations with particles at
+  // rest. We instead implement the WTA_modp_scheme
+  //
+  //   case WTA_E_scheme:{
+  //     const PseudoJet & phard = (pa.E() >= pb.E()) ? pa : pb;
+  //     /// keep 3-momentum direction and mass from the hardest, sum energies
+  //     ///
+  //     /// If the particle with the largest energy is at rest, the sum
+  //     /// remains at rest, implying that the mass of the sum is larger
+  //     /// than the mass of pa.
+  //     double Eab = pa.E() + pb.E();
+  //     double scale = (phard.modp2()==0.0)
+  //       ? 0.0
+  //       : sqrt((Eab*Eab - phard.m2())/phard.modp2());
+  //     pab.reset(phard.px()*scale, phard.py()*scale, phard.pz()*scale, Eab);
+  //     return;}
+  case WTA_modp_scheme:{
+    // Note: we need to compute both a and b modp. And we need pthard
+    // and its modp. If we want to avoid repeating the test and do
+    // only 2 modp calculations, we'd have to duplicate the code (or
+    // use a pair<const PJ&>). An alternative is to write modp_soft as
+    // modp_ab-modp_hard but this could suffer from larger rounding
+    // errors
+    bool a_hardest = (pa.modp2() >= pb.modp2());
+    const PseudoJet & phard = a_hardest ? pa : pb;
+    const PseudoJet & psoft = a_hardest ? pb : pa;
+    /// keep 3-momentum direction and mass from the hardest, sum modp
+    ///
+    /// If the hardest particle is at rest, the sum remains at rest
+    /// (the energy of the sum is therefore the mass of pa)
+    double modp_hard = phard.modp();
+    double modp_ab = modp_hard + psoft.modp();
+    if (phard.modp2()==0.0){
+      pab.reset(0.0, 0.0, 0.0, phard.m());
+    } else {
+      double scale = modp_ab/modp_hard;
+      pab.reset(phard.px()*scale, phard.py()*scale, phard.pz()*scale,
+                sqrt(modp_ab*modp_ab + phard.m2()));
+    }
+    return;}
   default:
     ostringstream err;
@@ -344,4 +399,7 @@
   case BIpt_scheme:
   case BIpt2_scheme:
+  case WTA_pt_scheme:
+  //case WTA_E_scheme:
+  case WTA_modp_scheme:
     break;
   case pt_scheme:
Index: external/fastjet/JetDefinition.hh
===================================================================
--- external/fastjet/JetDefinition.hh	(revision f14bd6a232a0c5f940f327c1f36da027f253ff56)
+++ external/fastjet/JetDefinition.hh	(revision 273e6686a07d03a86d9d25838b441c09754bdc34)
@@ -3,5 +3,5 @@
 
 //FJSTARTHEADER
-// $Id: JetDefinition.hh 3523 2014-08-02 13:15:21Z salam $
+// $Id: JetDefinition.hh 3677 2014-09-09 22:45:25Z soyez $
 //
 // Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
@@ -181,5 +181,13 @@
 
 //======================================================================
-/// the various recombination schemes
+/// The various recombination schemes
+///
+/// Note that the schemes that recombine with non-linear weighting of
+/// the directions (e.g. pt2, winner-takes-all) are collinear safe
+/// only for algorithms with a suitable ordering of the
+/// recombinations: orderings in which, for particles of comparable
+/// energies, small-angle clusterings take place before large-angle
+/// clusterings. This property is satisfied by all gen-kt algorithms.
+/// 
 enum RecombinationScheme {
   /// summing the 4-momenta
@@ -203,4 +211,22 @@
   /// no preprocessing
   BIpt2_scheme=6,
+  /// pt-based Winner-Takes-All (WTA) recombination: the
+  /// result of the recombination has the rapidity, azimuth and mass
+  /// of the the PseudoJet with the larger pt, and a pt equal to the
+  /// sum of the two pt's
+  WTA_pt_scheme=7,
+  /// mod-p-based Winner-Takes-All (WTA) recombination: the result of
+  /// the recombination gets the 3-vector direction and mass of the
+  /// PseudoJet with the larger |3-momentum| (modp), and a
+  /// |3-momentum| equal to the scalar sum of the two |3-momenta|.
+  WTA_modp_scheme=8,
+  // Energy-ordering can lead to dangerous situations with particles at
+  // rest. We instead implement the WTA_modp_scheme
+  //
+  // // energy-based Winner-Takes-All (WTA) recombination: the result of
+  // // the recombination gets the 3-vector direction and mass of the
+  // // PseudoJet with the larger energy, and an energy equal to the
+  // // to the sum of the two energies
+  // WTA_E_scheme=8,
   /// for the user's external scheme
   external_scheme = 99
Index: external/fastjet/PseudoJet.cc
===================================================================
--- external/fastjet/PseudoJet.cc	(revision f14bd6a232a0c5f940f327c1f36da027f253ff56)
+++ external/fastjet/PseudoJet.cc	(revision 273e6686a07d03a86d9d25838b441c09754bdc34)
@@ -1,4 +1,4 @@
 //FJSTARTHEADER
-// $Id: PseudoJet.cc 3565 2014-08-11 15:24:39Z salam $
+// $Id: PseudoJet.cc 3652 2014-09-03 13:31:13Z salam $
 //
 // Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
@@ -861,4 +861,5 @@
 PseudoJet join(const PseudoJet & j1, const PseudoJet & j2){
   vector<PseudoJet> pieces;
+  pieces.reserve(2);
   pieces.push_back(j1);
   pieces.push_back(j2);
@@ -869,4 +870,5 @@
 PseudoJet join(const PseudoJet & j1, const PseudoJet & j2, const PseudoJet & j3){
   vector<PseudoJet> pieces;
+  pieces.reserve(3);
   pieces.push_back(j1);
   pieces.push_back(j2);
@@ -878,4 +880,5 @@
 PseudoJet join(const PseudoJet & j1, const PseudoJet & j2, const PseudoJet & j3, const PseudoJet & j4){
   vector<PseudoJet> pieces;
+  pieces.reserve(4);
   pieces.push_back(j1);
   pieces.push_back(j2);
Index: external/fastjet/RectangularGrid.hh
===================================================================
--- external/fastjet/RectangularGrid.hh	(revision f14bd6a232a0c5f940f327c1f36da027f253ff56)
+++ external/fastjet/RectangularGrid.hh	(revision 273e6686a07d03a86d9d25838b441c09754bdc34)
@@ -88,6 +88,6 @@
   ///  \param rapmax     the maximal absolute rapidity extent of the grid
   ///  \param cell_size  the grid spacing (equivalently, cell size)
-  RectangularGrid(double rapmax, double cell_size) :
-      _ymax(rapmax), _ymin(-rapmax), 
+  RectangularGrid(double rapmax_in, double cell_size) :
+      _ymax(rapmax_in), _ymin(-rapmax_in), 
       _requested_drap(cell_size), _requested_dphi(cell_size) {
     _setup_grid();
@@ -103,8 +103,8 @@
   ///                        a massless 4-vector at the center of the tile passes
   ///                        the selection
-  RectangularGrid(double rapmin, double rapmax, double drap, double dphi,
+  RectangularGrid(double rapmin_in, double rapmax_in, double drap_in, double dphi_in,
                   Selector tile_selector = Selector()) 
-    : _ymax(rapmax), _ymin(rapmin), 
-      _requested_drap(drap), _requested_dphi(dphi),
+    : _ymax(rapmax_in), _ymin(rapmin_in), 
+      _requested_drap(drap_in), _requested_dphi(dphi_in),
       _tile_selector(tile_selector)
   {
Index: external/fastjet/Selector.hh
===================================================================
--- external/fastjet/Selector.hh	(revision f14bd6a232a0c5f940f327c1f36da027f253ff56)
+++ external/fastjet/Selector.hh	(revision 273e6686a07d03a86d9d25838b441c09754bdc34)
@@ -3,5 +3,5 @@
 
 //FJSTARTHEADER
-// $Id: Selector.hh 3504 2014-08-01 06:07:54Z soyez $
+// $Id: Selector.hh 3711 2014-09-29 13:54:51Z salam $
 //
 // Copyright (c) 2009-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
@@ -305,5 +305,5 @@
   }
 
-  /// class that gets throw when a Selector is applied despite it not
+  /// class that gets thrown when a Selector is applied despite it not
   /// having a valid underlying worker.
   class InvalidWorker : public Error {
@@ -312,6 +312,6 @@
   };
 
-  /// class that gets throw when a Selector is applied despite it not
-  /// having a valid underlying worker.
+  /// class that gets thrown when the area is requested from a Selector for which
+  /// the area is not meaningful
   class InvalidArea : public Error {
   public:
Index: external/fastjet/VERSION
===================================================================
--- external/fastjet/VERSION	(revision f14bd6a232a0c5f940f327c1f36da027f253ff56)
+++ external/fastjet/VERSION	(revision 273e6686a07d03a86d9d25838b441c09754bdc34)
@@ -1,1 +1,1 @@
-3.1.0-beta.1
+3.1.0
Index: external/fastjet/config_auto.h
===================================================================
--- external/fastjet/config_auto.h	(revision f14bd6a232a0c5f940f327c1f36da027f253ff56)
+++ external/fastjet/config_auto.h	(revision 273e6686a07d03a86d9d25838b441c09754bdc34)
@@ -64,4 +64,8 @@
 #endif
 
+/* defined if demangling is enabled at configure time and is supported through
+   the GNU C++ ABI */
+/* #undef HAVE_DEMANGLING_SUPPORT */
+
 /* Define to 1 if you have the <dlfcn.h> header file. */
 #ifndef FASTJET_HAVE_DLFCN_H 
@@ -147,5 +151,5 @@
 /* Define to the full name and version of this package. */
 #ifndef FASTJET_PACKAGE_STRING 
-#define FASTJET_PACKAGE_STRING  "FastJet 3.1.0-beta.1" 
+#define FASTJET_PACKAGE_STRING  "FastJet 3.1.0" 
 #endif
 
@@ -157,5 +161,5 @@
 /* Define to the version of this package. */
 #ifndef FASTJET_PACKAGE_VERSION 
-#define FASTJET_PACKAGE_VERSION  "3.1.0-beta.1" 
+#define FASTJET_PACKAGE_VERSION  "3.1.0" 
 #endif
 
@@ -167,5 +171,5 @@
 /* Version number of package */
 #ifndef FASTJET_VERSION 
-#define FASTJET_VERSION  "3.1.0-beta.1" 
+#define FASTJET_VERSION  "3.1.0" 
 #endif
 
@@ -182,16 +186,14 @@
 /* Version of the package under the form XYYZZ (instead of X.Y.Z) */
 #ifndef FASTJET_VERSION_NUMBER 
-#define FASTJET_VERSION_NUMBER  30103 
+#define FASTJET_VERSION_NUMBER  30100 
 #endif
 
 /* Patch version of this package */
 #ifndef FASTJET_VERSION_PATCHLEVEL 
-#define FASTJET_VERSION_PATCHLEVEL  3 
+#define FASTJET_VERSION_PATCHLEVEL  0 
 #endif
 
 /* Pre-release version of this package */
-#ifndef FASTJET_VERSION_PRERELEASE 
-#define FASTJET_VERSION_PRERELEASE  ".1.0-beta.1" 
-#endif
+/* #undef VERSION_PRERELEASE */
  
 /* once: _INCLUDE_FASTJET_CONFIG_AUTO_H */
Index: external/fastjet/config_raw.h
===================================================================
--- external/fastjet/config_raw.h	(revision f14bd6a232a0c5f940f327c1f36da027f253ff56)
+++ external/fastjet/config_raw.h	(revision 273e6686a07d03a86d9d25838b441c09754bdc34)
@@ -37,4 +37,8 @@
 /* The TrackJet plugin is enabled */
 #define ENABLE_PLUGIN_TRACKJET /**/
+
+/* defined if demangling is enabled at configure time and is supported through
+   the GNU C++ ABI */
+/* #undef HAVE_DEMANGLING_SUPPORT */
 
 /* Define to 1 if you have the <dlfcn.h> header file. */
@@ -88,5 +92,5 @@
 
 /* Define to the full name and version of this package. */
-#define PACKAGE_STRING "FastJet 3.1.0-beta.1"
+#define PACKAGE_STRING "FastJet 3.1.0"
 
 /* Define to the one symbol short name of this package. */
@@ -94,5 +98,5 @@
 
 /* Define to the version of this package. */
-#define PACKAGE_VERSION "3.1.0-beta.1"
+#define PACKAGE_VERSION "3.1.0"
 
 /* Define to 1 if you have the ANSI C header files. */
@@ -100,5 +104,5 @@
 
 /* Version number of package */
-#define VERSION "3.1.0-beta.1"
+#define VERSION "3.1.0"
 
 /* Major version of this package */
@@ -109,9 +113,9 @@
 
 /* Version of the package under the form XYYZZ (instead of X.Y.Z) */
-#define VERSION_NUMBER 30103
+#define VERSION_NUMBER 30100
 
 /* Patch version of this package */
-#define VERSION_PATCHLEVEL 3
+#define VERSION_PATCHLEVEL 0
 
 /* Pre-release version of this package */
-#define VERSION_PRERELEASE ".1.0-beta.1"
+/* #undef VERSION_PRERELEASE */
Index: external/fastjet/config_win.h
===================================================================
--- external/fastjet/config_win.h	(revision f14bd6a232a0c5f940f327c1f36da027f253ff56)
+++ external/fastjet/config_win.h	(revision 273e6686a07d03a86d9d25838b441c09754bdc34)
@@ -1,10 +1,9 @@
-#define FASTJET_PACKAGE_STRING  "FastJet 3.1.0-beta.1"
-#define FASTJET_PACKAGE_VERSION  "3.1.0-beta.1"
-#define FASTJET_VERSION  "3.1.0-beta.1"
+#define FASTJET_PACKAGE_STRING  "FastJet 3.1.0"
+#define FASTJET_PACKAGE_VERSION  "3.1.0"
+#define FASTJET_VERSION  "3.1.0"
 #define FASTJET_VERSION_MAJOR       3
 #define FASTJET_VERSION_MINOR       1
-#define FASTJET_VERSION_PATCHLEVEL  3
-#define FASTJET_VERSION_PRERELEASE  ".1.0-beta.1"
-#define FASTJET_VERSION_NUMBER      30103
+#define FASTJET_VERSION_PATCHLEVEL  0
+#define FASTJET_VERSION_NUMBER      30100
 
 /* The ATLASCone plugin is disabled by default*/
Index: external/fastjet/plugins/D0RunICone/fastjet/D0RunIConePlugin.hh
===================================================================
--- external/fastjet/plugins/D0RunICone/fastjet/D0RunIConePlugin.hh	(revision f14bd6a232a0c5f940f327c1f36da027f253ff56)
+++ external/fastjet/plugins/D0RunICone/fastjet/D0RunIConePlugin.hh	(revision 273e6686a07d03a86d9d25838b441c09754bdc34)
@@ -32,4 +32,5 @@
 //FJENDHEADER
 
+#include "fastjet/internal/base.hh" // namespace macros (include explicitly to help Doxygen)
 #include "D0RunIBaseConePlugin.hh"
 
Index: external/fastjet/plugins/D0RunICone/fastjet/D0RunIpre96ConePlugin.hh
===================================================================
--- external/fastjet/plugins/D0RunICone/fastjet/D0RunIpre96ConePlugin.hh	(revision f14bd6a232a0c5f940f327c1f36da027f253ff56)
+++ external/fastjet/plugins/D0RunICone/fastjet/D0RunIpre96ConePlugin.hh	(revision 273e6686a07d03a86d9d25838b441c09754bdc34)
@@ -32,4 +32,5 @@
 //FJENDHEADER
 
+#include "fastjet/internal/base.hh" // namespace macros (include explicitly to help Doxygen)
 #include "D0RunIBaseConePlugin.hh"
 
Index: external/fastjet/plugins/SISCone/SISConePlugin.cc
===================================================================
--- external/fastjet/plugins/SISCone/SISConePlugin.cc	(revision f14bd6a232a0c5f940f327c1f36da027f253ff56)
+++ external/fastjet/plugins/SISCone/SISConePlugin.cc	(revision 273e6686a07d03a86d9d25838b441c09754bdc34)
@@ -21,4 +21,56 @@
                       four_vector.E);
 }
+
+//======================================================================
+// wrap-up around siscone's user-defined scales
+namespace siscone_plugin_internal{
+  /// @ingroup internal
+  /// \class SISConeUserScale
+  /// class that makes the transition between the internal SISCone
+  /// user-defined scale choice (using SISCone's Cjet) and
+  /// user-defined scale choices in the plugn above (using FastJet's
+  /// PseudoJets)
+  class SISConeUserScale  : public siscone::Csplit_merge::Cuser_scale_base{
+  public:
+    /// ctor takes the "fastjet-style" user-defined scale as well as a
+    /// reference to the current cluster sequence (to access the
+    /// particles if needed)
+    SISConeUserScale(const SISConePlugin::UserScaleBase *user_scale,
+		     const ClusterSequence &cs)
+      : _user_scale(user_scale), _cs(cs){}
+
+    /// returns the scale associated to a given jet
+    virtual double operator()(const siscone::Cjet &jet) const{
+      return _user_scale->result(_build_PJ_from_Cjet(jet));
+    }
+
+    /// returns true id the scasle associated to jet a is larger than
+    /// the scale associated to jet b
+    virtual bool is_larger(const siscone::Cjet &a, const siscone::Cjet &b) const{
+      return _user_scale->is_larger(_build_PJ_from_Cjet(a), _build_PJ_from_Cjet(b));
+    }
+
+  private:
+    /// constructs a PseudoJet from a siscone::Cjet
+    ///
+    /// Note that it is tempting to overload the PseudoJet ctor. This
+    /// would not work because down the line we need to access the
+    /// original PseudoJet through the ClusterSequence and therefore
+    /// the PseudoJet structure needs to be aware of the
+    /// ClusterSequence.
+    PseudoJet _build_PJ_from_Cjet(const siscone::Cjet &jet) const{
+      PseudoJet j(jet.v.px, jet.v.py, jet.v.pz, jet.v.E);
+      j.set_structure_shared_ptr(SharedPtr<PseudoJetStructureBase>(
+                                   new SISConePlugin::UserScaleBaseStructureType<siscone::Cjet>(jet,_cs)));      
+      return j;
+    }
+
+    const SISConePlugin::UserScaleBase *_user_scale;
+    const ClusterSequence & _cs;
+  };
+}
+
+// end of the internal material
+//======================================================================
 
 
@@ -45,10 +97,21 @@
   desc << "SISCone jet algorithm with " ;
   desc << "cone_radius = "       << cone_radius        () << ", ";
-  desc << "overlap_threshold = " << overlap_threshold  () << ", ";
+  if (_progressive_removal)
+    desc << "progressive-removal mode, ";
+  else  
+    desc << "overlap_threshold = " << overlap_threshold  () << ", ";
   desc << "n_pass_max = "        << n_pass_max         () << ", ";
   desc << "protojet_ptmin = "    << protojet_ptmin()      << ", ";
-  desc <<  sm_scale_string                                << ", ";
-  desc << "caching turned "      << (caching() ? on : off);
-  desc << ", SM stop scale = "     << _split_merge_stopping_scale;
+  if (_progressive_removal && _user_scale) {
+    desc << "using a user-defined scale for ordering of stable cones";
+    string user_scale_desc = _user_scale->description();
+    if (user_scale_desc != "") desc << " (" << user_scale_desc << ")";
+  } else {
+    desc <<  sm_scale_string;
+  }
+  if (!_progressive_removal){
+    desc << ", caching turned "      << (caching() ? on : off);
+    desc << ", SM stop scale = "     << _split_merge_stopping_scale;
+  }
 
   // add a note to the description if we use the pt-weighted splitting
@@ -85,5 +148,5 @@
   bool new_siscone = true; // by default we'll be running it
 
-  if (caching()) {
+  if (caching() && !_progressive_removal) {
 
     // Establish if we have a cached run with the same R, npass and
@@ -138,7 +201,19 @@
     // run the jet finding
     //cout << "plg sms: " << split_merge_scale() << endl;
-    siscone->compute_jets(siscone_momenta, cone_radius(), overlap_threshold(),
-			  n_pass_max(), protojet_or_ghost_ptmin(), 
-			  Esplit_merge_scale(split_merge_scale()));
+    if (_progressive_removal){
+      // handle the optional user-defined scale choice
+      SharedPtr<siscone_plugin_internal::SISConeUserScale> internal_scale;
+      if (_user_scale){
+	internal_scale.reset(new siscone_plugin_internal::SISConeUserScale(_user_scale, clust_seq));
+	siscone->set_user_scale(internal_scale.get());
+      }
+      siscone->compute_jets_progressive_removal(siscone_momenta, cone_radius(),
+						n_pass_max(), protojet_or_ghost_ptmin(), 
+						Esplit_merge_scale(split_merge_scale()));
+    } else {
+      siscone->compute_jets(siscone_momenta, cone_radius(), overlap_threshold(),
+			    n_pass_max(), protojet_or_ghost_ptmin(), 
+			    Esplit_merge_scale(split_merge_scale()));
+    }
   } else {
     // rerun the jet finding
@@ -155,4 +230,8 @@
   SISConeExtras * extras = new SISConeExtras(n);
 
+  // the ordering in which the inclusive jets are transfered here is
+  // deliberate and ensures that when a user asks for
+  // inclusive_jets(), they are provided in the order in which SISCone
+  // created them.
   for (int ijet = njet-1; ijet >= 0; ijet--) {
     const Cjet & jet = siscone->jets[ijet]; // shorthand
@@ -220,3 +299,53 @@
 }
 
+// //======================================================================
+// // material to handle user-defined scales
+// 
+// //--------------------------------------------------
+// // SISCone structure type
+// 
+// // the textual descripotion
+// std::string SISConePlugin::UserScaleBase::StructureType::description() const{
+//   return "PseudoJet wrapping a siscone::Cjet stable cone"; 
+// }
+// 
+// // retrieve the constituents
+// //
+// // if you simply need to iterate over the constituents, it will be
+// // faster to access them via constituent(i)
+// vector<PseudoJet> SISConePlugin::UserScaleBase::StructureType::constituents(const PseudoJet &) const{ 
+//   vector<PseudoJet> constits;
+//   constits.reserve(_jet.n);
+//   for (unsigned int i=0; i<(unsigned int)_jet.n;i++)
+//     constits.push_back(constituent(i));
+//   return constits;
+// }
+// 
+// // returns the number of constituents
+// unsigned int SISConePlugin::UserScaleBase::StructureType::size() const{
+//   return _jet.n;
+// }
+// 
+// // returns the index (in the original particle list) of the ith
+// // constituent
+// int SISConePlugin::UserScaleBase::StructureType::constituent_index(unsigned int i) const{ 
+//   return _jet.contents[i];
+// }
+// 
+// // returns the ith constituent (as a PseusoJet)
+// const PseudoJet & SISConePlugin::UserScaleBase::StructureType::constituent(unsigned int i) const{
+//   return _cs.jets()[_jet.contents[i]];
+// }
+// 
+// // returns the scalar pt of this stable cone
+// double SISConePlugin::UserScaleBase::StructureType::pt_tilde() const{
+//   return _jet.pt_tilde;
+// }
+// 
+// // returns the sm_var2 (signed ordering variable squared) for this stable cone
+// double SISConePlugin::UserScaleBase::StructureType::ordering_var2() const{
+//   return _jet.sm_var2;
+// }
+
+
 FASTJET_END_NAMESPACE      // defined in fastjet/internal/base.hh
Index: external/fastjet/plugins/SISCone/config.h
===================================================================
--- external/fastjet/plugins/SISCone/config.h	(revision f14bd6a232a0c5f940f327c1f36da027f253ff56)
+++ external/fastjet/plugins/SISCone/config.h	(revision 273e6686a07d03a86d9d25838b441c09754bdc34)
@@ -49,11 +49,14 @@
 
 /* Define to the full name and version of this package. */
-#define PACKAGE_STRING "SISCone 2.0.6"
+#define PACKAGE_STRING "SISCone 3.0.0"
 
 /* Define to the one symbol short name of this package. */
 #define PACKAGE_TARNAME "siscone"
 
+/* Define to the home page for this package. */
+/* #undef PACKAGE_URL */
+
 /* Define to the version of this package. */
-#define PACKAGE_VERSION "2.0.6"
+#define PACKAGE_VERSION "3.0.0"
 
 /* Define to 1 if you have the ANSI C header files. */
@@ -61,3 +64,3 @@
 
 /* Version number of package */
-#define VERSION "2.0.6"
+#define VERSION "3.0.0"
